Kea: isc::dhcp::OptionDefParser Class Reference

| Kea 1.5.0

Public Member Functions | List of all members
isc::dhcp::OptionDefParser Class Reference

Parser for a single option definition. More...

`#include <dhcp_parsers.h>`

Inheritance diagram for isc::dhcp::OptionDefParser:
[legend]

## Public Member Functions
OptionDefinitionTuple | parse (isc::data::ConstElementPtr option_def)
| Parses an entry that describes single option definition. More...
Public Member Functions inherited from isc::data::SimpleParser
uint16_t | getUint16 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint16_t. More...
uint32_t | getUint32 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint32_t. More...
uint8_t | getUint8 (ConstElementPtr scope, const std::string &name)
| Get an uint8_t value. More...

## Additional Inherited Members
Static Public Member Functions inherited from isc::data::SimpleParser
static size_t | deriveParams (isc::data::ConstElementPtr parent, isc::data::ElementPtr child, const ParamsList &params)
| Derives (inherits) parameters from parent scope to a child. More...
static isc::asiolink::IOAddress | getAddress (const ConstElementPtr &scope, const std::string &name)
| Returns a IOAddress parameter from a scope. More...
static bool | getBoolean (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a boolean parameter from a scope. More...
static int64_t | getInteger (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer parameter from a scope. More...
static const data::Element::Position & | getPosition (const std::string &name, const data::ConstElementPtr parent)
| Utility method that returns position of an element. More...
static std::string | getString (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a string parameter from a scope. More...
static size_t | setDefaults (isc::data::ElementPtr scope, const SimpleDefaults &default_values)
| Sets the default values. More...
static size_t | setListDefaults (isc::data::ConstElementPtr list, const SimpleDefaults &default_values)
| Sets the default values for all entries in a list. More...
Protected Member Functions inherited from isc::data::SimpleParser
template<typename target_type , target_type convert>
target_type | getAndConvert (isc::data::ConstElementPtr scope, const std::string &name, const std::string &type_name)
| Returns a converted value from a scope. More...
template<typename int_type >
int_type | getIntType (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer value with range checking from a scope. More...

## Detailed Description

Parser for a single option definition.

This parser creates an instance of a single option definition.

Definition at line 228 of file dhcp_parsers.h.

## Member Function Documentation

## ◆ parse()

std::pair< isc::dhcp::OptionDefinitionPtr, std::string > isc::dhcp::OptionDefParser::parse | ( | isc::data::ConstElementPtr | option_def | ) |

Parses an entry that describes single option definition.

Parameters

  option_def | a configuration entry to be parsed.

Returns
  tuple (option definition, option space) of the parsed structure

Exceptions

  DhcpConfigError | if parsing was unsuccessful.

Definition at line 112 of file dhcp_parsers.cc.

References isc_throw, isc::util::str::tokens(), isc::util::str::trim(), and isc::Exception::what().

Referenced by isc::dhcp::ClientClassDefParser::parse(), and isc::dhcp::OptionDefListParser::parse().

Here is the call graph for this function:

The documentation for this class was generated from the following files:

- dhcp_parsers.h
- dhcp_parsers.cc